function varargout = SignalToPhasePlots_Collator(varargin)
%  SignalToPhasePlots_Collator is a GUI written by Gal Haspel for
%  collecting data of multiple signal to phase calcium traces, generated by
%  ImagignAnalysis02Intensity, into a single plot.
%  ratiometric and intensity stacks of calcium imaging.
%  Required functions: shadedErrorBar, expandAxes, (all available from MLCentral)

% SIGNALTOPHASEPLOTS_COLLATOR MATLAB code for SignalToPhasePlots_Collator.fig
%      SIGNALTOPHASEPLOTS_COLLATOR, by itself, creates a new SIGNALTOPHASEPLOTS_COLLATOR or raises the existing
%      singleton*.
%
%      H = SIGNALTOPHASEPLOTS_COLLATOR returns the handle to a new SIGNALTOPHASEPLOTS_COLLATOR or the handle to
%      the existing singleton*.
%
%      SIGNALTOPHASEPLOTS_COLLATOR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SIGNALTOPHASEPLOTS_COLLATOR.M with the given input arguments.
%
%      SIGNALTOPHASEPLOTS_COLLATOR('Property','Value',...) creates a new SIGNALTOPHASEPLOTS_COLLATOR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SignalToPhasePlots_Collator_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SignalToPhasePlots_Collator_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Last Modified by GUIDE v2.5 06-Nov-2018 18:42:34
% New Feature: a radio button is added. Its function: delete the first data
% point.
%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SignalToPhasePlots_Collator_OpeningFcn, ...
                   'gui_OutputFcn',  @SignalToPhasePlots_Collator_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% --- Executes just before SignalToPhasePlots_Collator is made visible.
function SignalToPhasePlots_Collator_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<INUSL>
%% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SignalToPhasePlots_Collator (see VARARGIN)

% Choose default command line output for SignalToPhasePlots_Collator
handles.output = hObject;

% load the mat file handles.PerimotorMinusSomaLocation that contains the
% adjustment to perimotor location of each motoneuron.
    handles.Numfiles=0;
    handles.fnames =[];
    handles.dFF = [];
    handles.RefFF = [];
    handles.PhaseSpace = [];
    handles.RefPhaseSpace = [];

% Update handles structure
guidata(hObject, handles);

% % Set waiting flag in appdata
% setappdata(handles.figureGUI,'waiting',1)
% % UIWAIT makes SignalToPhasePlots_Collator wait for user response (see UIRESUME)
%  uiwait(handles.figureGUI);


%% --- Outputs from this function are returned to the command line.
function varargout = SignalToPhasePlots_Collator_OutputFcn(hObject, eventdata, handles)  %#ok<INUSL>
%% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_LoadMatFiles.
function pushbutton_LoadMatFiles_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to pushbutton_LoadMatFiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
        
        if ~(exist('handles.fpath', 'var'))
            handles.fpath='C:\Users\Lan\Desktop\test\New folder';
        end
        
        
        [fname,handles.fpath]=uigetfile({'*.mat'},'Select a mat file', handles.fpath);

        
     if get(handles.checkbox_LoadFolder,'Value') % ticked - all files in forlder
         FolderFileList = ls(handles.fpath);
         [FolderNumFiles, ~] = size(FolderFileList);
     else % not ticked- load one file at a time
         FolderFileList = [fname; fname; fname];
         FolderNumFiles = 3;
         
     end

     handles.FolderNumFiles = FolderNumFiles;
     for ii = 3:FolderNumFiles % 3 is due to ls function returning . and .. in places 1 and 2
        fname = FolderFileList(ii,:);
        load ([handles.fpath fname], 'dFF', 'PhaseSpace')   
        
        if get(handles.radiobutton_DeleteFirstFrame, 'Value')
            dFF = dFF(2:length(dFF),:);
            PhaseSpace= PhaseSpace(2:length(PhaseSpace),:);
        end
        if ~exist( 'dFF', 'var')||~exist( 'PhaseSpace', 'var') % check mat file has relevant data, return if not
            return
            fprintf([handles.fpath fname 'is not a relevant file\n'])
        end
         
         % if a datapoint exist within 10 deg around 0 or 180 deg, add to referenced dFF   
        if  any(355<=PhaseSpace| PhaseSpace<=5 | (175<=PhaseSpace & PhaseSpace<=185))
            RefPoint = mean(dFF(355<=PhaseSpace| PhaseSpace<=5 | (175<=PhaseSpace & PhaseSpace<=185)));
            handles.RefFF = [handles.RefFF; dFF/RefPoint];
            handles.RefPhaseSpace = [handles.RefPhaseSpace; PhaseSpace];
        end
%
        handles.Numfiles=handles.Numfiles+1;
        handles.dFF = [handles.dFF; dFF];
        handles.PhaseSpace = [handles.PhaseSpace; PhaseSpace];
        handles.fnames = [handles.fnames; fname];
        set(handles.text_YFileName, 'String', handles.fnames);
     end      
            set(handles.pushbutton_save,'visible','on');
            set(handles.text_FileName,'visible','on');
            set(handles.popupmenu_PhaseResolution,'visible','on');
            set(handles.popupmenu_VarMeasure,'visible','on');
            set(handles.togglebutton_Plot,'visible','on');            
            set(handles.popupmenu_WhichPlots,'visible','on');
            set(handles.text_FolderName,'visible','on');
            set(handles.edit_UserComments,'visible','on');
            set(handles.text5,'visible','on');
            set(handles.text14,'visible','on');
            set(handles.text18,'visible','on');
            set(handles.text19,'visible','on');
            set(handles.edit_NeurNameText,'visible','on');
            set(handles.edit_ForBack,'visible','on');
            set(handles.edit_Genotype,'visible','on');
            set(handles.popupmenu_RefPoint, 'visible','on');
            set(handles.text20, 'visible','on');
            set(handles.text21, 'visible','on');
            set(handles.text22, 'visible','on');
            set(handles.text_NumFilesPoints, 'visible','on');
            set(handles.text_NumFilesPoints, 'string',...
                [num2str(handles.Numfiles) 'files, ' num2str(length(handles.dFF)) ' data points, ' num2str(length(handles.RefFF)) ' normalizable data points']);
            
guidata(hObject,handles)
%% --- Executes on button press in pushbutton_save.
function pushbutton_save_Callback(hObject, eventdata, handles)%#ok<DEFNU,INUSL>
%% hObject    handle to pushbutton_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.fnameT = [datestr(now, 'yymmddTHHMM') '_' get(handles.edit_NeurNameText, 'String')...
                '_' get(handles.edit_ForBack, 'String') '_' get(handles.edit_Genotype, 'String')];
set(gcf,'PaperPositionMode','auto')
cd (handles.fpath)
    %this is what will be saved:
    SctrPlotPhaseSpace = handles.SctrPlotPhaseSpace; %#ok<NASGU>
    SctrPlotdFF = handles.SctrPlotdFF; %#ok<NASGU>
    LinePlotErrBars = handles.LinePlotErrBars; %#ok<NASGU>
    LinePlotPhaseSpace = handles.LinePlotPhaseSpace;%#ok<NASGU>
    LinePlotdFF = handles.LinePlotdFF;%#ok<NASGU>
    RefFF = handles.RefFF; %#ok<NASGU>
    RefPhaseSpace = handles.RefPhaseSpace; %#ok<NASGU>
save (handles.fnameT, 'SctrPlotPhaseSpace', 'SctrPlotdFF', 'LinePlotErrBars', 'LinePlotPhaseSpace', 'LinePlotdFF', 'RefPhaseSpace', 'RefFF');
set(handles.text_FileName, 'String', handles.fnameT);
print(handles.figureGUI,handles.fnameT,'-dpng') %save a pic of the GUI after file name is written
guidata(hObject,handles)

%%


function edit_NeurNameText_Callback(hObject, eventdata, handles)%#ok<INUSD,DEFNU>
% hObject    handle to edit_NeurNameText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_NeurNameText as text
%        str2double(get(hObject,'String')) returns contents of edit_NeurNameText as a double

% --- Executes during object creation, after setting all properties.
function edit_NeurNameText_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to edit_NeurNameText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_UserComments_Callback(hObject, eventdata, handles)%#ok<INUSD,DEFNU>
% hObject    handle to edit_UserComments (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_UserComments as text
%        str2double(get(hObject,'String')) returns contents of edit_UserComments as a double

% --- Executes during object creation, after setting all properties.
function edit_UserComments_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to edit_UserComments (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in pushbutton_close.
function pushbutton_close_Callback(hObject, eventdata, handles) %#ok<DEFNU,INUSL>
% hObject    handle to pushbutton_close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Close the GUI
close(handles.figureGUI); 


% --- Executes on selection change in popupmenu_PhaseResolution.
function popupmenu_PhaseResolution_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to popupmenu_PhaseResolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_PhaseResolution contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_PhaseResolution

% --- Executes during object creation, after setting all properties.
function popupmenu_PhaseResolution_CreateFcn(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to popupmenu_PhaseResolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupmenu_VarMeasure.
function popupmenu_VarMeasure_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to popupmenu_VarMeasure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function popupmenu_VarMeasure_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_VarMeasure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% --- Executes on button press in togglebutton_Plot.
function togglebutton_Plot_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to togglebutton_Plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% collect values of popupmenus

contents = cellstr(get(handles.popupmenu_PhaseResolution,'String'));
handles.PhaseResolution = str2double(contents{get(handles.popupmenu_PhaseResolution,'Value')});

contents = cellstr(get(handles.popupmenu_RefPoint,'String'));
            switch contents{get(handles.popupmenu_RefPoint,'Value')}        
                case 'None'
                    handles.SctrPlotPhaseSpace = round(handles.PhaseSpace/handles.PhaseResolution)*handles.PhaseResolution;
                    handles.SctrPlotdFF = handles.dFF;
                case '0 or 180 deg'
                    handles.SctrPlotPhaseSpace = round(handles.RefPhaseSpace/handles.PhaseResolution)*handles.PhaseResolution;
                    handles.SctrPlotdFF = handles.RefFF;
            end
% The line plot is the means of all points at every x axis value
contents = cellstr(get(handles.popupmenu_VarMeasure,'String'));
jj = 0;
handles.LinePlotPhaseSpace = [];
handles.LinePlotdFF = [];
handles.LinePlotErrBars = [];

for ii = [0:handles.PhaseResolution:360]
    if any(handles.SctrPlotPhaseSpace == ii)
        jj=jj+1;
        handles.LinePlotPhaseSpace(jj) = ii;
        handles.LinePlotdFF(jj) = mean(handles.dFF(handles.SctrPlotPhaseSpace == ii));    
            switch contents{get(handles.popupmenu_VarMeasure,'Value')}        
                case 'None'
                    handles.LinePlotErrBars(jj) = 0; % no error bars
                case 'SEM'
                    handles.LinePlotErrBars(jj) = (std(handles.dFF(handles.SctrPlotPhaseSpace == ii))/sqrt(sum(handles.SctrPlotPhaseSpace == ii)));
                case 'SD'
                    handles.LinePlotErrBars(jj) = std(handles.dFF(handles.SctrPlotPhaseSpace == ii));
            end        
    end
end

handles.LinePlotdFF(1) = mean([handles.dFF(handles.SctrPlotPhaseSpace == 0) ; handles.dFF(handles.SctrPlotPhaseSpace == 360)]); %Added by Lan on 170727
handles.LinePlotdFF(jj)= handles.LinePlotdFF(1); %Added by Lan on 170727, to make the value of 0 deg and 360 deg equal.
handles.LinePlotErrBars(1) = std([handles.dFF(handles.SctrPlotPhaseSpace == 0);handles.dFF(handles.SctrPlotPhaseSpace == 360)]);
handles.LinePlotErrBars(jj) = handles.LinePlotErrBars(1);

PlotTitle = [get(handles.edit_NeurNameText, 'String') ' ' get(handles.edit_ForBack, 'String') ' ' get(handles.edit_Genotype, 'String')];

%% trace plot
        contents = cellstr(get(handles.popupmenu_WhichPlots,'String'));
        switch contents{get(handles.popupmenu_WhichPlots,'Value')}
            case 'Scatter'
                plot(handles.axes_SignalPhasePlot,handles.SctrPlotPhaseSpace,handles.SctrPlotdFF, 'ok')
                set(handles.axes_SignalPhasePlot, 'XLim', [0 360], 'XTick', [0, 90, 180, 270, 360], 'XGrid', 'on',...
        'YLim', [0.8*min(handles.SctrPlotdFF) 1.2*max(handles.SctrPlotdFF)])
            case 'Line'
                shadedErrorBar(handles.LinePlotPhaseSpace,handles.LinePlotdFF,handles.LinePlotErrBars,...
                                            '-b', 1)%H=shadedErrorBar(x,y,errBar,lineProps,transparent) 
                                        set(handles.axes_SignalPhasePlot, 'XLim', [0 360], 'XTick', [0, 90, 180, 270, 360], 'XGrid', 'on');
            case 'Both'
                plot(handles.axes_SignalPhasePlot,handles.SctrPlotPhaseSpace,handles.SctrPlotdFF, 'ok')      
                hold on
                shadedErrorBar(handles.LinePlotPhaseSpace,handles.LinePlotdFF,handles.LinePlotErrBars,...
                                            '-b', 1)%H=shadedErrorBar(x,y,errBar,lineProps,transparent)
                set(handles.axes_SignalPhasePlot, 'XLim', [0 360], 'XTick', [0, 90, 180, 270, 360], 'XGrid', 'on',...
        'YLim', [0.8*min(handles.SctrPlotdFF) 1.2*max(handles.SctrPlotdFF)])
        end            
        
        title(PlotTitle)
        hold off
        expandAxes(handles.axes_SignalPhasePlot)
        set(handles.text_FolderName, 'String', handles.fpath);
        set(handles.pushbutton_save, 'visible', 'on'); %allow to save only after ploting agains phase    
        set(handles.pushbutton_MorePlots,'visible','on');
        
        handles.UndFreqPlotTitle = PlotTitle;
guidata(hObject,handles)




% --- Executes on selection change in popupmenu_WhichPlots.
function popupmenu_WhichPlots_Callback(hObject, eventdata, handles) %#ok<INUSD,DEFNU>
% hObject    handle to popupmenu_WhichPlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_WhichPlots contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_WhichPlots


% --- Executes during object creation, after setting all properties.
function popupmenu_WhichPlots_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_WhichPlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupmenu_ForBack.
function popupmenu_ForBack_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_ForBack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_ForBack contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_ForBack

% --- Executes during object creation, after setting all properties.
function popupmenu_ForBack_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_ForBack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_Genotype_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Genotype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Genotype as text
%        str2double(get(hObject,'String')) returns contents of edit_Genotype as a double


% --- Executes during object creation, after setting all properties.
function edit_Genotype_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Genotype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_ForBack_Callback(hObject, eventdata, handles)
% hObject    handle to edit_ForBack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_ForBack as text
%        str2double(get(hObject,'String')) returns contents of edit_ForBack as a double


% --- Executes during object creation, after setting all properties.
function edit_ForBack_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_ForBack (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_RefPoint.
function popupmenu_RefPoint_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_RefPoint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_RefPoint contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_RefPoint


% --- Executes during object creation, after setting all properties.
function popupmenu_RefPoint_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_RefPoint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_LoadFolder.
function checkbox_LoadFolder_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_LoadFolder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_LoadFolder


% --- Executes during object creation, after setting all properties.
function pushbutton_LoadMatFiles_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton_LoadMatFiles (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in radiobutton_DeleteFirstFrame.
function radiobutton_DeleteFirstFrame_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_DeleteFirstFrame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_DeleteFirstFrame


% --- Executes during object creation, after setting all properties.
function togglebutton_Plot_CreateFcn(hObject, eventdata, handles)
% hObject    handle to togglebutton_Plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pushbutton_MorePlots.
function pushbutton_MorePlots_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_MorePlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 FolderFileList = ls(handles.fpath);
 allUndFreq = NaN(1,handles.FolderNumFiles-2);
 k = 1;
for ii = 3:handles.FolderNumFiles % 3 is due to ls function returning . and .. in places 1 and 2
        
        fname = FolderFileList(ii,:);
        load ([handles.fpath fname], 'UndFreq');
        allUndFreq(1,k) = UndFreq;
        k = k + 1;
end  
figure;
notBoxPlot(allUndFreq);
temp = ['Undulation Frequency; ' handles.UndFreqPlotTitle];
title(temp);
display(allUndFreq);
meanUndFreq = mean(allUndFreq);
display(meanUndFreq);
stdUndFreq = std(allUndFreq);
display(stdUndFreq);
temp = [temp '.mat'];
save(temp,'allUndFreq');





% --- Executes during object creation, after setting all properties.
function pushbutton_MorePlots_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton_MorePlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pushbutton18.
function pushbutton18_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function axes_SignalPhasePlot_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes_SignalPhasePlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes_SignalPhasePlot
