function varargout = ImagingAnalyzer02_1_intensity(varargin)
% IMAGINGANALYZER02INTENSITY MATLAB code for ImagingAnalyzer02intensity.fig
%      IMAGINGANALYZER02INTENSITY, by itself, creates a new IMAGINGANALYZER02INTENSITY or raises the existing
%      singleton*.
%
%      H = IMAGINGANALYZER02INTENSITY returns the handle to a new IMAGINGANALYZER02INTENSITY or the handle to
%      the existing singleton*.
%
%      IMAGINGANALYZER02INTENSITY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in IMAGINGANALYZER02INTENSITY.M with the given input arguments.
%
%      IMAGINGANALYZER02INTENSITY('Property','Value',...) creates a new IMAGINGANALYZER02INTENSITY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ImagingAnalyzer02intensity_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ImagingAnalyzer02intensity_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

%  ImagingAnalyzer02intensity is a GUI written by Gal Haspel for analyzing
%  ratiometric and intensity stacks of calcium imaging.
%  Required functions: EzFit, show_image, expandAxes, tiffread30 (all
%  available from MLCentral)

%Computation of Undulation Frequency is added in
%ImagingAnalyzer02_1_intensity.m by Lan Deng on 2017/04/01

%to do: 
%       (Cant do this->move calculation of handle.PhaseSpace to after )
%       add a "reset figure" button and activate the "reset all" 
%       allow longer file name to include the index number or analyzed file
%       frame number during analysis and on output fig

% Last Modified by GUIDE v2.5 19-May-2017 15:34:59

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ImagingAnalyzer02_1_intensity_OpeningFcn, ...
                   'gui_OutputFcn',  @ImagingAnalyzer02_1_intensity_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% --- Executes just before ImagingAnalyzer02_1_intensity is made visible.
function ImagingAnalyzer02_1_intensity_OpeningFcn(hObject, eventdata, handles, varargin) %#ok<INUSL>
%% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ImagingAnalyzer02intensity (see VARARGIN)

% Choose default command line output for ImagingAnalyzer02intensity
handles.output = hObject;

% load the mat file handles.PerimotorMinusSomaLocation that contains the
% adjustment to perimotor location of each motoneuron.
    if exist('C:\Users\HASPEL LAB\Documents\MATLAB\20190405_Tiff Analyzer for CalImg_RealTwoChannel - corrected HeadRL\PerimotorMinusSomaLocation.mat', 'file')
        load('C:\Users\HASPEL LAB\Documents\MATLAB\20190405_Tiff Analyzer for CalImg_RealTwoChannel - corrected HeadRL\PerimotorMinusSomaLocation.mat',...
        'PerimotorMinusSomaLocation');
    else
        [filename,filepath]=uigetfile('PerimotorMinusSomaLocation.mat','find file PerimotorMinusSomaLocation.mat to use this code');
        load([filepath '/' filename]);        
        
    end
    handles.PerimotorMinusSomaLocation = PerimotorMinusSomaLocation;

% Update handles structure
guidata(hObject, handles);

% % Set waiting flag in appdata
% setappdata(handles.figureGUI,'waiting',1)
% % UIWAIT makes ImagingAnalyzer02intensity wait for user response (see UIRESUME)
%  uiwait(handles.figureGUI);


%% --- Outputs from this function are returned to the command line.
function varargout = ImagingAnalyzer02_1_intensity_OutputFcn(hObject, eventdata, handles)  %#ok<INUSL>
%% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_LoadFilesSTK.
function pushbutton_LoadFilesSTK_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to pushbutton_LoadFilesSTK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
        [handles.fnameY,handles.pathY]=uigetfile({'*.tif';'*.tiff';'*.stk'},'Select stk or tiff', 'C:\');
        handles.readYellow = tiffread30([handles.pathY '/' handles.fnameY]); %use tiffread to get data (tiffread3.0 is latest v)
        handles.width= handles.readYellow(1).width; 
        handles.height = handles.readYellow(1).height; 
        bits = handles.readYellow(1).bits; 
        handles.bits=['uint' num2str(bits)]; 
        handles.Nframes = length (handles.readYellow);
        handles.Y = zeros(handles.height, handles.width,  handles.Nframes);  %size allocation for handles.Y
        
                % in case metadata does not include frame rate, take from GUI (if exist, update in GUI
                framerate=str2double(get(handles.FrameRate,'String'));
                if isnan(framerate)||framerate<1, framerate=1; end
                if exist('handles.readYellow(ii).datetime', 'var'), framerate= ((datenum( handles.readYellow(handles.Nframes).datetime(end-12:end))-...
                                datenum( handles.readYellow(1).datetime(end-12:end)))*(24*60*60))/handles.Nframes; end
                set(handles.FrameRate,'String', framerate) % update value on GUI (metadata overrules)
        for ii=1:handles.Nframes 
            handles.Y(:,:,ii)=handles.readYellow(ii).data; 
          if exist('handles.readYellow(ii).datetime', 'var')% is there time stamp in metadata?
            if handles.readYellow(ii).datetime(end-3)=='.' %fixes a bug in tiffread that misses a zero when only 2 not 3 digits after decimal point
                handles.readYellow(ii).datetime(end-12:end) = ...
                    [handles.readYellow(ii).datetime(end-11:end-3), '0', handles.readYellow(ii).datetime(end-2:end)];
            end 
            handles.time(ii)=(datenum( handles.readYellow(ii).datetime(end-12:end))-...
                                datenum( handles.readYellow(1).datetime(end-12:end)))*(24*60*60); %time stamp is in days. convert to seconds   
          else
            handles.time(ii)= (ii-1)* 1/framerate; % if time stamp is missing from metadata, convert frame rate to seconds.
          end
        end

        handles.axes_FullFrameFig = imshow(handles.Y(:,:,1), [], 'parent', handles.axes_FullFrame, 'colormap', parula,'Border','tight','InitialMagnification','fit');
        set(handles.axes_FullFrameFig,'visible','on');
        set(handles.edit_FirstFrame,'visible','on');
        set(handles.edit_LastFrame,'visible','on');
        set(handles.pushbutton_TrackPlot, 'visible', 'on')
        set(handles.text15, 'visible', 'on')
        set(handles.text17, 'visible', 'on')        
        set(handles.text_YFileName, 'String', handles.fnameY);
        set(handles.text_FolderName, 'String', handles.pathY); 
        set(handles.edit_LastFrame, 'String', int2str(handles.Nframes));
        guidata(hObject,handles)

% --- Executes on selection change in popupmenu_RatioIntensity.
function popupmenu_RatioIntensity_Callback(hObject, eventdata, handles)  %#ok<INUSL,DEFNU>
% hObject    handle to popupmenu_RatioIntensity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_RatioIntensity contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_RatioIntensity
contents = cellstr(get(hObject,'String'));
switch contents{get(hObject,'Value')}
    case 'Intensity' 
        set(handles.text_YaxisTitle, 'String', 'dF/F');
        set(handles.axes_FullFrame,'visible','on');        
end
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function popupmenu_RatioIntensity_CreateFcn(hObject, eventdata, handles) %#ok<*INUSD,DEFNU>
% hObject    handle to popupmenu_RatioIntensity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupmenu_BackgroundSub.
function popupmenu_BackgroundSub_Callback(hObject, eventdata, handles)  %#ok<INUSL,DEFNU>
% hObject    handle to popupmenu_BackgroundSub (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_BackgroundSub contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_BackgroundSub
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function popupmenu_BackgroundSub_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_BackgroundSub (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% --- Executes on button press in pushbutton_TrackPlot.
function pushbutton_TrackPlot_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
%% hObject    handle to pushbutton_TrackPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
FromFrame=str2double(get(handles.edit_FirstFrame,'String'));
ToFrame=str2double(get(handles.edit_LastFrame,'String'));
    if isnan(FromFrame)||FromFrame<1 ||FromFrame>handles.Nframes-1
         FromFrame=1;
         set(handles.edit_FirstFrame,'String', '1')
    end
    if isnan(ToFrame)||ToFrame<2 ||ToFrame>handles.Nframes
         ToFrame=handles.Nframes1;
         set(handles.edit_FirstFrame,'String', str2double(handles.Nframes))
    end
    YtoTrack=handles.Y(:, :, FromFrame:ToFrame);
    rYtoTrack=handles.rY(:, :, FromFrame:ToFrame);
    contentsBG = cellstr(get(handles.popupmenu_BackgroundSub,'String'));
switch contentsBG{get(handles.popupmenu_BackgroundSub,'Value')}
    case 'No background sub'
        handles.BGmethod='n';
    case 'Median of image'
        handles.BGmethod='m';
    case 'Median except ROI'
        handles.BGmethod='o';
    case 'Background ROI'
        handles.BGmethod='r';
end

contents = cellstr(get(handles.popupmenu_trackingMethod,'String'));
switch contents{get(handles.popupmenu_trackingMethod,'Value')}
    case 'Threshold around ROI'
        ThrshCorr=str2double(get(handles.edit_TrackingParam,'String'));
        if isnan(ThrshCorr)||ThrshCorr<0 ||ThrshCorr>1
             ThrshCorr=0.2;
             set(handles.edit_TrackingParam,'String', '0.2')
        end
        [handles.Ytrace, Mrgn, Brgn, handles.trk, handles.Ntrk] = ...
        IAThresholdTracker02intensity(YtoTrack, handles.height, handles.width, (ToFrame-FromFrame+1), handles.BGmethod, ThrshCorr); %#ok<ASGLU>
       
    case 'Manual (click each)' %IAZoomManualTracker03intensity, not 02
        [handles.Ytrace, handles.rYtrace, Mrgn, Brgn, handles.trk, handles.Ntrk] = ...
        IAZoomManualTracker03intensity(YtoTrack,rYtoTrack,handles.height, handles.width,...
                (ToFrame-FromFrame+1), handles.BGmethod, handles.FirstFrameNumber); %#ok<ASGLU>
        
    case 'Tamplate arounf ROI'
      [handles.trk, ROIimage, T_error]=LKforNeurTracking(Vmovie, ROI, hAxis, DVmovie); %#ok<ASGLU>
      
      % do this
      
    case 'No tracking (ROI)'
       handles.trk = zeros((ToFrame-FromFrame+1), 2);
       hFROI= figure('Position',get(0,'ScreenSize'));
       hIROI=show_image(handles.Y(:,:,FromFrame), 'Magnification', 0.4, 'Handle', hFROI); 
       [Trgn, xT, yT] = roipoly;
        for ii = 1:size(YtoTrack,3)
             Y = YtoTrack(:,:,ii); 
                switch handles.BGmethod
                    case 'o' 
                    Brgn=~Trgn;    
                    bgY= median(reshape(Y(Brgn), 1, []));
                    case 'm'
                    bgY= median(reshape(Y, 1, []));
                    case 'r'
                     hold(hIROI,'on')
                     plot(hIROI, xT, yT,'-b','LineWidth',1);
                    [Brgn, xB, yB] = roipoly;
                    bgY= median(reshape(Y(Brgn), 1, []));         
                    otherwise
                    bgY= 0;
                end
             handles.Ytrace(ii) = mean(Y(Trgn))-bgY;  %measuring ROI in yellow    
                cla(hIROI)
                show_image(YtoTrack(:,:,ii), 'Handle', hIROI);
                hold(hIROI,'on')
                plot(hIROI, xT, yT,'-b','LineWidth',1); % shows new location of measuring ROI after tracking
                if exist('xB', 'var'),plot(imgca, xB, yB,'-r','LineWidth',1); end % shows new location of measuring ROI after tracking
                drawnow;         
        end  
       close(hFROI) 
       handles.trk(:,1)= min(xT) + (max(xT)-min(xT))/2; %keep location to insert name
       handles.trk(:,2)= min(yT) + (max(yT)-min(yT))/2; %keep location to insert name
       handles.Ntrk=size(YtoTrack,3); %can't track out. trk will only have one value
end %for switch/cases tracking method
    handles.trk=handles.trk(1:handles.Ntrk,:); %take off the zeros off the end
    cla(handles.axes_FullFrame)
    handles.axes_FullFrameFig = imshow(handles.Y(:,:,str2double(get(handles.edit_FirstFrame,'String')))+handles.Ntrk,...
                [], 'parent', handles.axes_FullFrame, 'colormap', parula,'Border','tight','InitialMagnification','fit');
    hold (handles.axes_FullFrame, 'on')
    plot (handles.axes_FullFrame, handles.trk(:,1),handles.trk(:,2), 'k:o', 'LineWidth',2)
    axes(handles.axes_FullFrame)
    axes(handles.axes_FullFrame)
    text(30, 30, num2str(handles.FirstFrameNumber), 'FontSize',10, 'color', 'white')   % post first and last frames numbers on image
    text(size(handles.Y, 1)-100, 30, num2str(handles.FirstFrameNumber+handles.Ntrk), 'FontSize',10, 'color', 'white') 
%% trace plot
contents = cellstr(get(handles.popupmenu_dFoverF,'String'));
switch contents{get(handles.popupmenu_dFoverF,'Value')} %how to calculate dF/F
    case 'dF/F: first value' %divide by first value
        handles.dFFtrace = handles.Ytrace./handles.Ytrace(1);
    case 'dF/F: demean' %demean: divide by mean value
        handles.dFFtrace = handles.Ytrace./mean(handles.Ytrace);
    case 'dF/F: exponent (bleaching)' % divide by fitted exponent (good to compensate for bleaching) 
        f = ezfit(handles.Ytrace, 'f(t)=a*exp(-t/tau)');% fit a single exponent for bleaching correction using ezfit toolbox
        dexp = f.m(1)*exp(-[1:size(handles.Ytrace,2)]/f.m(2));   %#ok<NBRAK>
        handles.dFFtrace = handles.Ytrace./dexp; %dFFtrace is dF/F by division by fitted exponent        
    case 'raw value' % no dF/F. use intensity values
        handles.dFFtrace = handles.Ytrace;
    case 'ratio: GCaMP/Red'
        handles.dFFtrace = handles.Ytrace./handles.rYtrace ;
    case 'ratio: RCaMP/Green'
        handles.dFFtrace = handles.Ytrace./handles.rYtrace ;
end
plot(handles.axes_Traces,handles.time(1:length(handles.dFFtrace)),handles.dFFtrace, 'k','LineWidth',2)
set(handles.axes_Traces, 'XLim', [0 handles.time(handles.Ntrk)])
set(handles.axes_Traces, 'YLim', [0.8*min(handles.dFFtrace) 1.2*max(handles.dFFtrace)])
hold off
expandAxes(handles.axes_Traces)
% make needed buttons visible after trace is plotted
set(handles.pushbutton_NameNeuron, 'visible', 'on')
set(handles.edit_NameText, 'visible', 'on')
set(handles.pushbutton_filter, 'visible', 'on')
set(handles.popupmenu_Objective, 'visible', 'on')
set(handles.popupmenu_HeadLR, 'visible', 'on')
set(handles.popupmenu_PhaseToMark, 'visible', 'on')
set(handles.togglebutton_TimeOrPhase, 'visible', 'on')

guidata(hObject,handles)

% --- Executes on button press in pushbutton_filter.
function pushbutton_filter_Callback(hObject, eventdata, handles) %#ok<DEFNU,INUSL>
% hObject    handle to pushbutton_filter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

guidata(hObject,handles)

% --- Executes on button press in pushbutton_save.
function pushbutton_save_Callback(hObject, eventdata, handles)%#ok<DEFNU,INUSL>
% hObject    handle to pushbutton_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.NeurName=get(handles.edit_NameText, 'String');
handles.fnameT = [datestr(now, 'yymmddTHHMM') handles.fnameY(1:10) '_' handles.NeurName...
                [num2str(get(handles.popupmenu_RatioIntensity, 'value')) ...
                 num2str(get(handles.popupmenu_trackingMethod, 'value')) ...
                 num2str(get(handles.popupmenu_BackgroundSub, 'value'))]];
set(gcf,'PaperPositionMode','auto')
cd (handles.pathY)
    figname = [handles.fnameT '_display two channels.png'];
    
    saveas(handles.PlotTwoChannels,figname);
    close(handles.PlotTwoChannels);
    %this is what will be saved:
    dFF=handles.dFFtrace; %#ok<NASGU>
    Ytrace=handles.Ytrace; %#ok<NASGU>
    rYtrace = handles.rYtrace;
    %ratioYtrace = handles.ratioYtrace;
    Time=handles.time(1:length(handles.Ytrace)); %#ok<NASGU>
    NeurName=handles.NeurName; %#ok<NASGU>
    PhaseSpace=handles.PhaseSpace; %#ok<NASGU>
    UndFreq = handles.UndFreq;
save (handles.fnameT, 'dFF', 'Ytrace', 'rYtrace','NeurName', 'Time', 'PhaseSpace','UndFreq');
set(handles.text_FileName, 'String', handles.fnameT); 
print(handles.figureGUI,handles.fnameT,'-dpng') %save a pic of the GUI after file name is written
guidata(hObject,handles)

% --- Executes on selection change in popupmenu_trackingMethod.
function popupmenu_trackingMethod_Callback(hObject, eventdata, handles)%#ok<DEFNU,INUSL>
% hObject    handle to popupmenu_trackingMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_trackingMethod contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_trackingMethod

guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function popupmenu_trackingMethod_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_trackingMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_TrackingParam_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to edit_TrackingParam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_TrackingParam as text
%        str2double(get(hObject,'String')) returns contents of edit_TrackingParam as a double


% --- Executes during object creation, after setting all properties.
function edit_TrackingParam_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to edit_TrackingParam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_ResetAll.
function pushbutton_ResetAll_Callback(hObject, eventdata, handles)%#ok<DEFNU,INUSL>
% hObject    handle to pushbutton_ResetAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


guidata(hObject,handles)

% --- Executes on button press in pushbutton_NameNeuron.
function pushbutton_NameNeuron_Callback(hObject, eventdata, handles)%#ok<DEFNU,INUSL>
% hObject    handle to pushbutton_NameNeuron (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.NeurName=get(handles.edit_NameText, 'String');
        %nameXY= handles.trk(handles.Ntrk,:);
        nameXY= handles.trk(1,:);
        if nameXY(1)<handles.width, nameXY(1)=nameXY(1)-20; else nameXY(1)=nameXY(1)+20; end
        if nameXY(2)<handles.height, nameXY(2)=nameXY(2)-20; else nameXY(2)=nameXY(2)+20; end
        axes(handles.axes_FullFrame);
        text(nameXY(1), nameXY(2), handles.NeurName, 'FontSize',18, 'color', 'yellow')        
guidata(hObject,handles)

function edit_NameText_Callback(hObject, eventdata, handles)%#ok<DEFNU>
% hObject    handle to edit_NameText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_NameText as text
%        str2double(get(hObject,'String')) returns contents of edit_NameText as a double

% --- Executes during object creation, after setting all properties.
function edit_NameText_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to edit_NameText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit4_Callback(hObject, eventdata, handles)%#ok<DEFNU>
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double

% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in pushbutton_close.
function pushbutton_close_Callback(hObject, eventdata, handles) %#ok<DEFNU,INUSL>
% hObject    handle to pushbutton_close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Close the GUI
close(handles.figureGUI); 

function FrameRate_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to FrameRate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FrameRate as text
%        str2double(get(hObject,'String')) returns contents of FrameRate as a double

% --- Executes during object creation, after setting all properties.
function FrameRate_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to FrameRate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in togglebutton_LoadFilesTiffs.
function togglebutton_LoadFilesTiffs_Callback(hObject, eventdata, handles) %#ok<DEFNU,INUSL>
% hObject    handle to togglebutton_LoadFilesTiffs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
        [handles.fnameY,handles.pathY]=uigetfile({'*.tif';'*.tiff'},'Select the first Calcium Sensor Image of a series of tiffs', 'A:\Lan_Thesis\TOL11_0.5% Methyl Cellulose\170320_TOL11_0.5%MC_10ms\');
        Uscores=strfind(handles.fnameY, '_');
        UscoresFromBack = length(handles.fnameY)-Uscores;
        handles.FirstFrameNumber= str2double(handles.fnameY(Uscores(1)+1:Uscores(2)-1));
        inx= handles.FirstFrameNumber;% running index for data files begins with the index of selected file
        ii=1;
        fname = [handles.pathY handles.fnameY];
        handles.readYellow = imfinfo(fname);
        %NextFname = [fname(1:end-7) num2str(inx, '%03d') '.tif'];
        %consider allocating handles.Y and taking the extra off after the while loop
                % in case metadata does not include frame rate, take from GUI (if exist, update in GUI
                framerate=str2double(get(handles.FrameRate,'String'));
                if isnan(framerate)||framerate<1, framerate=1; end
                set(handles.FrameRate,'String', framerate) % update value on GUI (metadata overrules)
        
        while exist([fname(1:(end-UscoresFromBack(1))) num2str(inx, '%09d') fname((end-UscoresFromBack(2)):end)], 'file')
            handles.Y(:,:,ii)= imread([fname(1:(end-UscoresFromBack(1))) num2str(inx, '%09d') fname((end-UscoresFromBack(2)):end)]);
            contents = cellstr(get(handles.popupmenu_dFoverF,'String'));
            if strcmp(contents{get(handles.popupmenu_dFoverF,'Value')},'ratio: GCaMP/Red')==1
            nameRchannel =  [fname(1:(end-UscoresFromBack(1))) num2str(inx, '%09d') '_RedImg.tif'];
            elseif strcmp(contents{get(handles.popupmenu_dFoverF,'Value')},'ratio: RCaMP/Green')==1
            nameRchannel =  [fname(1:(end-UscoresFromBack(1))) num2str(inx, '%09d') '_GreenImg.tif'];
            end
            handles.rY(:,:,ii) = imread(nameRchannel); % "r" represents the REFERENCE channel, NOT Red
            handles.time(ii)= (ii-1)* 1/framerate; % if time stamp is missing from metadata, convert frame rate to seconds.
            inx = inx+1;
            ii=ii+1;
            %NextFname = [fname(1:end-7) num2str(inx, '%03d') '.tif'];
        end
        
        [handles.width, handles.height, handles.Nframes]= size(handles.Y);
        bits = handles.readYellow(1).BitsPerSample; 
        handles.bits=['uint' num2str(bits)]; 
        handles.Nframes = ii-1;
 handles.axes_FullFrameFig = imshow(handles.Y(:,:,1), [], 'parent', handles.axes_FullFrame, 'colormap', parula,'Border','tight','InitialMagnification','fit');
        set(handles.axes_FullFrameFig,'visible','on');
        set(handles.edit_FirstFrame, 'visible','on');
        set(handles.edit_LastFrame, 'String', int2str(handles.Nframes),'visible','on');
        set(handles.pushbutton_TrackPlot, 'visible', 'on')
        set(handles.text15, 'visible', 'on')
        set(handles.text17, 'visible', 'on')        
        set(handles.text_YFileName, 'String', handles.fnameY);
        set(handles.text_FolderName, 'String', handles.pathY); 
        %set(handles.edit_LastFrame, 'String', int2str(handles.Nframes));
        guidata(hObject,handles)
% Hint: get(hObject,'Value') returns toggle state of togglebutton_LoadFilesTiffs

function edit_FirstFrame_Callback(hObject, eventdata, handles) %#ok<DEFNU,INUSL>
% hObject    handle to edit_FirstFrame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%handles.axes_FullFrameFig = imagesc(handles.Y(:,:,str2double(get(hObject,'String'))), 'Parent', handles.axes_FullFrame);
FromFrame=str2double(get(handles.edit_FirstFrame,'String'));
ToFrame=str2double(get(handles.edit_LastFrame,'String'));
    if isnan(FromFrame)||FromFrame<1 ||FromFrame>handles.Nframes-1
         FromFrame=1; %#ok<NASGU>
         set(handles.edit_FirstFrame,'String', '1')
    end
    if isnan(ToFrame)||ToFrame<2 ||ToFrame>handles.Nframes
         ToFrame=handles.Nframes1; %#ok<NASGU>
         set(handles.edit_FirstFrame,'String', str2double(handles.Nframes))
    end
handles.axes_FullFrameFig = imshow(handles.Y(:,:,str2double(get(hObject,'String'))),...
                    [], 'parent', handles.axes_FullFrame, 'colormap', parula,'Border','tight','InitialMagnification','fit');
                
% Hints: get(hObject,'String') returns contents of edit_FirstFrame as text
%        str2double(get(hObject,'String')) returns contents of edit_FirstFrame as a double

% --- Executes during object creation, after setting all properties.
function edit_FirstFrame_CreateFcn(hObject, eventdata, handles)  %#ok<DEFNU>
% hObject    handle to edit_FirstFrame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_LastFrame_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to edit_LastFrame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
FromFrame=str2double(get(handles.edit_FirstFrame,'String'));
ToFrame=str2double(get(handles.edit_LastFrame,'String'));
    if isnan(FromFrame)||FromFrame<1 ||FromFrame>handles.Nframes-1,
         FromFrame=1; %#ok<NASGU>
         set(handles.edit_FirstFrame,'String', '1')
    end
    if isnan(ToFrame)||ToFrame<2 ||ToFrame>handles.Nframes,
         ToFrame=handles.Nframes1; %#ok<NASGU>
         set(handles.edit_FirstFrame,'String', str2double(handles.Nframes))
    end
% Hints: get(hObject,'String') returns contents of edit_LastFrame as text
%        str2double(get(hObject,'String')) returns contents of edit_LastFrame as a double

% --- Executes during object creation, after setting all properties.
function edit_LastFrame_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to edit_LastFrame (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupmenu_Objective.
function popupmenu_Objective_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to popupmenu_Objective (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(handles.popupmenu_Objective,'String'));
switch contents{get(handles.popupmenu_Objective,'Value')} %how to calculate dF/F
    case 'choose one' %
        handles.CycleSizeInPixels = 0; %THIS IS A VERY ROUGH APPROXIMATION!!!!
    case '40x' %
        handles.CycleSizeInPixels = 3060; % Cycle length in pixels, measured for the specific 40x and Flash4 camera
end
% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_Objective contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_Objective

% --- Executes during object creation, after setting all properties.
function popupmenu_Objective_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_Objective (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupmenu_PhaseToMark.
function popupmenu_PhaseToMark_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to popupmenu_PhaseToMark (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
    switch contents{get(hObject,'Value')}
        case 'Choose one'
            handles.PhaseAnchorVal = 'NaN';
        case '0 deg'
            handles.PhaseAnchorVal = 0;
        case '90 deg'
            handles.PhaseAnchorVal = 90;
        case '180 deg'
            handles.PhaseAnchorVal = 180;
        case '270 deg' 
            handles.PhaseAnchorVal = 270;
    end
    [handles.PhaseAnchorXY(1), handles.PhaseAnchorXY(2), keystroke] = ginput(1);  %#ok<ASGLU>
    text(handles.PhaseAnchorXY(1), handles.PhaseAnchorXY(2), contents{get(hObject,'Value')}, 'FontSize',18, 'color', 'red')
    
guidata(hObject,handles)
% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_PhaseToMark contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_PhaseToMark

% --- Executes during object creation, after setting all properties.
function popupmenu_PhaseToMark_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_PhaseToMark (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in togglebutton_TimeOrPhase.
function togglebutton_TimeOrPhase_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to togglebutton_TimeOrPhase (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% calculate the phase from X (handles.trk(:,1)), using phase marked (handles.PhaseAnchorVal), 
%        location of mark (handles.PhaseAnchorXY), direction of head (handles.HeadLR), and neuron identity (handles.NeurName) 
%% collect values of popupmenus
contents = cellstr(get(handles.popupmenu_HeadLR,'String'));
switch contents{get(handles.popupmenu_HeadLR,'Value')}
    case 'choose one'
        handles.HeadLR = 0;        
    case 'Head left'
        handles.HeadLR = 1; 
    case 'Head right'
        handles.HeadLR = (-1);
end
contents = cellstr(get(handles.popupmenu_Objective,'String'));
switch contents{get(handles.popupmenu_Objective,'Value')} %how to calculate dF/F
    case 'choose one' %
        handles.CycleSizeInPixels = 0; %THIS IS A VERY ROUGH APPROXIMATION!!!!
    case '40x' %
        handles.CycleSizeInPixels = 3060; % Cycle length in pixels, measured for the specific 40x and Flash4 camera
end
contents = cellstr(get(handles.popupmenu_PhaseToMark,'String'));
switch contents{get(handles.popupmenu_PhaseToMark,'Value')}
    case 'Choose one'
        handles.PhaseAnchorVal = 'NaN';
    case '0 deg'
        handles.PhaseAnchorVal = 0;
    case '90 deg'
        handles.PhaseAnchorVal = 90;
    case '180 deg'
        handles.PhaseAnchorVal = 180;
    case '270 deg' 
        handles.PhaseAnchorVal = 270;
end
% contents = cellstr(get(handles.popupmenu_HeadLR,'String'));
% switch contents{get(handles.popupmenu_HeadLR,'Value')}
%     case 'choose one'
%         handles.HeadLR = 0;        
%     case 'Head left'
%         handles.HeadLR = 1; 
%     case 'Head right'
%         handles.HeadLR = (-1);
% end
handles.NeurName=get(handles.edit_NameText, 'String');
if length(handles.NeurName)~=4 || find(strcmp(handles.PerimotorMinusSomaLocation(:,1),handles.NeurName))==0
    sound([sin(1:.3:200), sin(1:.15:300)]) % nope
        return     
else
    handles.NMJofset = ...
        handles.PerimotorMinusSomaLocation{find(strcmp(handles.PerimotorMinusSomaLocation(:,1),handles.NeurName)),4}*handles.CycleSizeInPixels;  
end
% 
% switch handles.NeurName(1:2) %set ofset from neuron name and size of cycle
%     case {'DA', 'VA', 'AS'}
%         handles.NMJofset= 0.1*handles.CycleSizeInPixels; %0.1 is ROUGH ESTIMATE!!!! values from wormatlas/wiring/Neuronfixedpoints.exl (Beth Chen 2005)
%     case {'DB', 'VB'}
%         handles.NMJofset= (-0.1)*handles.CycleSizeInPixels;
%     case {'DD', 'VD', 'VC'}
%         handles.NMJofset= 0;
%     otherwise
%         sound([sin(1:.3:200), sin(1:.15:300)]) % nope
%         return 
% end

%% if value was not selected for objective,phase location, head direction and neuron name, return without changes
     if strcmp(handles.PhaseAnchorVal, 'NaN')||...
        handles.CycleSizeInPixels == 0||...
        handles.HeadLR == 0
        sound([sin(1:.2:200), sin(1:.15:300)]) % nope
        return  
     end
handles.NeurName=get(handles.edit_NameText, 'String');     
     if handles.NeurName(1)~='D'&&handles.NeurName(1)~='V'&&handles.NeurName(1)~='A'&&...
             handles.NeurName(2)~='A'&&handles.NeurName(2)~='B'&&handles.NeurName(2)~='C'&&...
             handles.NeurName(2)~='D'&&handles.NeurName(2)~='S'&&...
             handles.NeurName(2)~='M'
        sound([sin(1:.4:200), sin(1:.15:300)]) % nope
        return  
     end
     
%%


%determine location of zero deg if 90, 180 or 270 were selected by adding quarter cycle for each
% handles.PhaseAnchorVal % which phase point was marked on the image
% handles.PhaseAnchorXY  % coordinate
% handles.HeadLR % direction of animal. angles increase from head to tail.
handles.ZeroPhaseAnchorXY = handles.PhaseAnchorXY-(handles.HeadLR*(handles.PhaseAnchorVal)/90)*(handles.CycleSizeInPixels/4); % 

%Variables for the calc
% handles.trk(1:handles.Ntrk,1)
% handles.HeadLR % 'choose one'= 0; 'Head left'= 1; 'Head right'= (-1);
% handles.NeurName
% handles.CycleSizeInPixels
% handles.ZeroPhaseAnchorXY
% handles.NMJofset % phase shift from soma to NMJ: VA, DA, AS 0.1 cycale anteriorly, DB, VB 0.1 cycle posteriorly

% calculate x values in phase space
handles.PhaseSpace = 360*((handles.HeadLR*((handles.trk(1:handles.Ntrk,1)-handles.ZeroPhaseAnchorXY(1))/handles.CycleSizeInPixels)) ... %distance from data-points to zero point, divided by cycle size
                      +handles.HeadLR*handles.NMJofset/handles.CycleSizeInPixels); %adds the ofset in pixels from the motoneuronal soma to the NMJ, more anterior for As, posterior for Bs

handles.PhaseSpace(handles.PhaseSpace>360)=handles.PhaseSpace(handles.PhaseSpace>360)-360; % "circling" angles
handles.PhaseSpace(handles.PhaseSpace<0)=handles.PhaseSpace(handles.PhaseSpace<0)+360; % "circling" angles
% WORKING HERE

%% trace plot
contents = cellstr(get(handles.popupmenu_dFoverF,'String'));
switch contents{get(handles.popupmenu_dFoverF,'Value')} %how to calculate dF/F
    case 'dF/F: first value' %divide by first value
        handles.dFFtrace = handles.Ytrace./handles.Ytrace(1);
    case 'dF/F: demean' %demean: divide by mean value
        handles.dFFtrace = handles.Ytrace./mean(handles.Ytrace);
    case 'dF/F: exponent (bleaching)' % divide by fitted exponent (good to compensate for bleaching) 
        f = ezfit(handles.Ytrace, 'f(t)=a*exp(-t/tau)');% fit a single exponent for bleaching correction using ezfit toolbox
        dexp = f.m(1)*exp(-[1:size(handles.Ytrace,2)]/f.m(2));   %#ok<NBRAK>
        handles.dFFtrace = handles.Ytrace./dexp; %dFFtrace is dF/F by division by fitted exponent        
    case 'raw value' % no dF/F. use intensity values
        handles.dFFtrace = handles.Ytrace;    
end

    switch get(handles.togglebutton_TimeOrPhase,'String')
        case {'Time (s)' 'Press for Phase'} 
            set(handles.togglebutton_TimeOrPhase, 'String', 'Phase (deg)');
            % IF X TO DEG DOES NOT EXIST: ASK TO MARK PHASE
            % PLOT dF/F AGAINST PHASE
            plot(handles.axes_Traces,handles.PhaseSpace,handles.dFFtrace, 'ok')            
            set(handles.axes_Traces, 'XLim', [0 360], 'XTick', [0, 90, 180, 270, 360], 'XGrid', 'on',...
            'YLim', [0.8*min(handles.dFFtrace) 1.2*max(handles.dFFtrace)])
        case 'Phase (deg)' 
            set(handles.togglebutton_TimeOrPhase, 'String', 'Time (s)'); 
            % PLOT dF/F AGAINST TIME
            plot(handles.axes_Traces,handles.time(1:length(handles.dFFtrace)),handles.dFFtrace, 'k','LineWidth',2)
            set(handles.axes_Traces, 'YLim', [0.8*min(handles.dFFtrace) 1.2*max(handles.dFFtrace)]);
    end
hold off

%Plot calcium signal/time, reference signal/time, calcium signal/phase,
%reference signal/phase
%while exist(handles.PlotTwoChannels)== 0
handles.PlotTwoChannels = figure;
subplot(4,1,1);
plot(handles.time(1:length(handles.Ytrace)),handles.Ytrace, 'k','LineWidth',2);
    xlabel('Time (sec)');
    ylabel('Signal from Calcium Sensor');
    title('Calium signal over time');  
subplot(4,1,2);
plot(handles.time(1:length(handles.rYtrace)),handles.rYtrace, 'k','LineWidth',2);
    xlabel('Time (sec)');
    ylabel('Signal from Reference Protein');
    title('Reference protein signal over time');    
subplot(4,1,3);
plot(handles.PhaseSpace,handles.Ytrace, 'ok');             
    set(gca, 'XLim', [0 360], 'XTick', [0, 90, 180, 270, 360], 'XGrid', 'on',...
            'YLim', [0.8*min(handles.Ytrace) 1.2*max(handles.Ytrace)])
    xlabel('Phase Position (deg)');
    ylabel('Signal from Calcium Sensor');
    title('Calium signal over phase');  

subplot(4,1,4);
plot(handles.PhaseSpace,handles.rYtrace, 'ok');             
    set(gca, 'XLim', [0 360], 'XTick', [0, 90, 180, 270, 360], 'XGrid', 'on',...
            'YLim', [0.8*min(handles.rYtrace) 1.2*max(handles.rYtrace)])
    xlabel('Phase Position (deg)');
    ylabel('Signal from Reference Protein');
    title('Reference protein signal over phase');  
set(handles.PlotTwoChannels, 'Position', [680 100 560 800]); 
%end
%Plot based on ratio of the two channels
%figure;
%subplot(2,1,1);
%plot(handles.time(1:length(handles.ratioYtrace)), handles.ratioYtrace);

%subplot(2,1,2);
%plot(handles.PhaseSpace,handles.ratioYtrace, 'ok')
%xlim([0 360]);


%% Calculate Undulation Frequency
%170330_Added by Lan
handles.framerate=str2double(get(handles.FrameRate,'String'));
time = 1/ handles.framerate * handles.Ntrk;
Ncycle =  abs(handles.trk(1,1)-handles.trk(length(handles.trk),1))/handles.CycleSizeInPixels;
handles.UndFreq = Ncycle/time;
display(handles.UndFreq)


expandAxes(handles.axes_Traces)
set(handles.pushbutton_save, 'visible', 'on') %allow to save only after ploting agains phase    
guidata(hObject,handles)

% --- Executes on selection change in popupmenu_dFoverF.
function popupmenu_dFoverF_Callback(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_dFoverF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ADD HERE CHANGING dFF AFTERTRACE GENERATED

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_dFoverF contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_dFoverF

% --- Executes during object creation, after setting all properties.
function popupmenu_dFoverF_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_dFoverF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_HeadLR.
function popupmenu_HeadLR_Callback(hObject, eventdata, handles) %#ok<INUSL,DEFNU>
% hObject    handle to popupmenu_HeadLR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
switch contents{get(hObject,'Value')}
    case 'choose one'
        handles.HeadLR = 0;        
    case 'Head left'
        handles.HeadLR = 1; 
    case 'Head right'
        handles.HeadLR = (-1);
end



% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_HeadLR contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_HeadLR


% --- Executes during object creation, after setting all properties.
function popupmenu_HeadLR_CreateFcn(hObject, eventdata, handles) %#ok<DEFNU>
% hObject    handle to popupmenu_HeadLR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_ResetImage.
function pushbutton_ResetImage_Callback(hObject, eventdata, handles) %#ok<DEFNU,INUSL>
% hObject    handle to pushbutton_ResetImage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% this resets the tracking image in case a mistake was made in labeling or
% plotting
    cla(handles.axes_FullFrame)
    handles.axes_FullFrameFig = imshow(handles.Y(:,:,str2double(get(handles.edit_FirstFrame,'String')))+handles.Ntrk,...
                [], 'parent', handles.axes_FullFrame, 'colormap', parula,'Border','tight','InitialMagnification','fit');
    hold (handles.axes_FullFrame, 'on')
    plot (handles.axes_FullFrame, handles.trk(:,1),handles.trk(:,2), 'k:o', 'LineWidth',2)
    text(30, 30, num2str(handles.FirstFrameNumber), 'FontSize',10, 'color', 'white')   % post first and last frames numbers on image
    text(size(handles.Y, 1)-100, 30, num2str(handles.FirstFrameNumber+handles.Ntrk), 'FontSize',10, 'color', 'white') 
guidata(hObject,handles)


% --- Executes during object creation, after setting all properties.
function togglebutton_LoadFilesTiffs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to togglebutton_LoadFilesTiffs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
